<?php
if (!defined('ABSPATH')) {
    exit;
}
class WC_Gateway_JCC_Payment_Redirect extends WC_Payment_Gateway
{
    public function __construct()
    {
        if (!function_exists('write_log')) {
            function write_log($log)
            {
                if (is_array($log) || is_object($log)) {
                    error_log(print_r($log, true));
                } else {
                    error_log($log);
                }
            }
        }
        $this->id = 'jccpaymentgatewayredirect';
        $this->method_title = __('JCC', 'JCC_Payment_Redirect');
        $this->method_description = __('', 'JCC_Payment_Redirect');
        $this->has_fields = true;
        $this->view_transaction_url = '';
        $this->supports = array(
            
        );

        $this->init_form_fields();
        $this->init_settings();

        $this->title = __($this->get_option('title'), 'JCC_Payment_Redirect');
        $this->description = __($this->get_option('description'),'JCC_Payment_Redirect');
        $this->enabled = $this->get_option('enabled');
        $this->merchantid = $this->get_option('merchantid');
        $this->acquirerid = $this->get_option('acquirerid');
        $this->password = $this->get_option('password');
        $this->responseurl = $this->get_option('responseurl');
        $this->requesturl = $this->get_option('requesturl');



        add_action('woocommerce_receipt_jccpaymentgatewayredirect', array($this, 'thankyou'));
        add_action('woocommerce_api_' . strtolower(get_class($this)), array(&$this, 'jcc_callback'));

        add_action('woocommerce_update_options_payment_gateways_' . $this->id, array($this, 'process_admin_options'));

        

    }
    function admin_options() {
       parent::admin_options();
       return;
       echo '<div style="padding:15px">
       <label style="display:block;">Additional Information</label>
       <a type="button" class="button" style="display:block;width:120px;text-align:center;margin-top:5px" href="https://www.jcc.com.cy/become-a-merchant/" target="_blank">JCC Forms</a>
       
       ' . add_thickbox() . '
       <div style="display:none" id="jccpremium" TB_title="Premium Features">
            
            <p>
                <label style="display:block">Premium Features:</label>
                <ul style="list-style-type:circle;padding-left:15px">
                   <li>JCC merchant application form in a simple wizard</li>
                   <li>Credit Card Tokenization for easy checkout process</li>
                   <li>Reports of transactions succeeded and failed</li>
                   <li>One click refunds from within the woocommerce order panel</li>
                   <li></li>
                </ul>
            </p>
        </div>
       <a class="thickbox button" type="button" style="display:block;width:120px;text-align:center;margin-top:5px" href="#TB_inline?height=300&amp;width=400&amp;inlineId=jccpremium;" >
         Get Premium
       </a>
       </div>';
       parent::admin_options();

    }
    public function process_admin_options()
    {
        if (is_user_logged_in() && current_user_can('manage_options')) {
            if (!is_ssl()) {
                unset($_POST['woocommerce_jccpaymentgatewayredirect_enabled']);
                WC_Admin_Settings::add_error(__('HTTPS is required.', 'JCC_Payment_Redirect'));
            }
            if (
                !isset($_POST['woocommerce_jccpaymentgatewayredirect_merchantid']) || empty($_POST['woocommerce_jccpaymentgatewayredirect_merchantid']) ||
                !isset($_POST['woocommerce_jccpaymentgatewayredirect_acquirerid']) || empty($_POST['woocommerce_jccpaymentgatewayredirect_acquirerid']) ||
                !isset($_POST['woocommerce_jccpaymentgatewayredirect_title']) || empty($_POST['woocommerce_jccpaymentgatewayredirect_title']) ||
                !isset($_POST['woocommerce_jccpaymentgatewayredirect_description']) || empty($_POST['woocommerce_jccpaymentgatewayredirect_description']) ||
                !isset($_POST['woocommerce_jccpaymentgatewayredirect_password']) || empty($_POST['woocommerce_jccpaymentgatewayredirect_password']) ||
                !isset($_POST['woocommerce_jccpaymentgatewayredirect_responseurl']) || empty($_POST['woocommerce_jccpaymentgatewayredirect_responseurl']) ||
                !isset($_POST['woocommerce_jccpaymentgatewayredirect_requesturl']) || empty($_POST['woocommerce_jccpaymentgatewayredirect_requesturl'])
            ) {
                
                unset($_POST['woocommerce_jccpaymentgatewayredirect_enabled']);
                WC_Admin_Settings::add_error(__('All fields are required.', 'JCC_Payment_Redirect'));
            }
            parent::process_admin_options();
        }
    }
    public function jcc_callback()
    {
        try {
            $data = !empty($_POST) ? $_POST : array();
            if (empty($data)) {
                exit;
            }
            if (empty($data['OrderID'])) {
                exit;
            }

            $orderID = absint($data['OrderID']);
            if (empty($orderID)) {
                exit;
            }
            $order = wc_get_order($orderID);
            if (empty($order)) {
                exit;
            }
            if ($order->needs_payment() == false) {
                exit;
            }
            $redirect_url = $this->get_return_url($order);
            if (!empty($data['ResponseCode']) && !empty($data['ReasonCode'])) {
                $jccResponseCode = intval($data['ResponseCode']);
                $jccReasonCode = intval($data['ReasonCode']);
                if (($jccResponseCode == 1 && $jccReasonCode == 1)) {
                    $jccAuthNo = $data['AuthCode'];
                    if (!empty($jccAuthNo)) {
                        include_once 'class-wc-gateway-jcc-payment-gateway-redirect-request.php';
                        $request = new WC_Gateway_JCC_Payment_Gateway_Redirect_Request($this);
                        $form = $request->get_args($order);
                        $jccRef = $_POST['ReferenceNo'];
                        $jccPaddedCardNo = $_POST['PaddedCardNo'];
                        $toEncrypt = $this->password . $this->merchantid . $this->acquirerid . $orderID . $jccResponseCode . $jccReasonCode;
                        $sha1Signature = sha1($toEncrypt);
                        $expectedsha = base64_encode(pack("H*", $sha1Signature));
                        if ($expectedsha == $data['ResponseSignature']) {
                            $order->payment_complete($jccRef);
                            WC()->cart->empty_cart();
                            $redirect_url = add_query_arg(array('response_code' => $data['ResponseCode'], 'transaction_id' => $jccRef), $redirect_url);
                            echo $this->get_redirect_html($redirect_url);
                            exit;
                        }
                    }
                }
            }
            if (empty($data['ReasonCodeDesc'])) {
                exit;
            }
            $order->update_status('failed', $data['ReasonCodeDesc']);
            $redirect_url = add_query_arg('wc_error', $data['ReasonCodeDesc'], $order->get_checkout_payment_url(true));
            echo $this->get_redirect_html($redirect_url);
            exit;
        } catch (Exception $e) {
            $order->update_status('failed', $e->getMessage());
            $redirect_url = add_query_arg('wc_error', $e->getMessage(), $order->get_checkout_payment_url(true));
            echo $this->get_redirect_html($redirect_url);
            exit;
        }
    }
    public static function get_redirect_html($redirect_url)
    {
        return "<html><head><script language=\"javascript\">
			<!--
			window.location=\"{$redirect_url}\";
			//-->
			</script>
			</head><body><noscript><meta http-equiv=\"refresh\" content=\"1;url={$redirect_url}\"></noscript></body></html>";
    }
    public function init_form_fields()
    {
        $this->form_fields = include 'class-wc-gateway-jcc-payment-gateway-redirect-settings.php';
    }
    public function process_payment($order_id)
    {
        if ($this->enabled == true) {
            $order = wc_get_order($order_id);
            return array(
                'result' => 'success',
                'redirect' => $order->get_checkout_payment_url($order),
            );
        }
    }
    public function thankyou($order_id)
    {
        $order = wc_get_order($order_id);

        if ($order->needs_payment() == true && !isset($_GET['wc_error'])) {
            include_once 'class-wc-gateway-jcc-payment-gateway-redirect-request.php';
            $request = new WC_Gateway_JCC_Payment_Gateway_Redirect_Request($this);
            echo $request->getform($order);
            echo '<script type="text/javascript">document.forms["paymentForm"].submit();</script>';
        } elseif ($order->needs_payment() == true && isset($_GET['wc_error'])) {
            include_once 'class-wc-gateway-jcc-payment-gateway-redirect-request.php';
            $request = new WC_Gateway_JCC_Payment_Gateway_Redirect_Request($this);
            echo $request->getform($order);
            echo '<button onclick="submitpaymentform()">Retry</button>';
            echo '<script type="text/javascript">function submitpaymentform() { window.location = "' . $order->get_checkout_payment_url($order) . '" }</script>';
        } else {
            echo '<script type="text/javascript">window.location = "' . $this->get_return_url($order) . '"</script>';
        }
    }
}
